CREATE OR REPLACE FUNCTION RQ_STR_TO_STRING (string_in IN VARCHAR2) RETURN VARCHAR2 IS
BEGIN
  IF STRING_IN IS NULL THEN
    RETURN NULL;
  END IF;
  RETURN string_in;
EXCEPTION
  WHEN OTHERS
  THEN RETURN '';
END RQ_STR_TO_STRING;
/
CREATE OR REPLACE FUNCTION RQ_STR_TO_NUMBER (string_in IN VARCHAR2) RETURN NUMBER IS
BEGIN
  IF STRING_IN IS NULL THEN
    RETURN NULL;
  END IF;
  RETURN TO_NUMBER (string_in);
EXCEPTION
  WHEN OTHERS
  THEN RETURN 0;
END RQ_STR_TO_NUMBER;
/
CREATE OR REPLACE FUNCTION RQ_STR_TO_DATE (string_in IN VARCHAR2) RETURN DATE IS
BEGIN
  IF STRING_IN IS NULL THEN
    RETURN NULL;
  END IF;
  RETURN TO_DATE (string_in, 'MM/DD/YYYY');
EXCEPTION
  WHEN OTHERS
  THEN RETURN TO_DATE('12/30/1899', 'MM/DD/YYYY');
END RQ_STR_TO_DATE;
/
CREATE OR REPLACE FUNCTION RQ_STR_TO_TIME (string_in IN VARCHAR2) RETURN DATE IS
BEGIN
  IF STRING_IN IS NULL THEN
    RETURN NULL;
  END IF;
  RETURN TO_DATE (string_in, 'HH24:MI:SS');
EXCEPTION
  WHEN OTHERS
  THEN RETURN TO_DATE('12/30/1899 00:00:00', 'MM/DD/YYYY HH24:MI:SS');
END RQ_STR_TO_TIME;
/
CREATE OR REPLACE FUNCTION RQ_WORDAND (v_Mask IN NUMBER, v_Value IN NUMBER) RETURN NUMBER IS
  v_CurrBit NUMBER;
  v_NumA NUMBER;
  v_NumB NUMBER;
  v_MaxParam NUMBER;
  v_MaxBits NUMBER;
  v_ResComp NUMBER;
  v_BitA BOOLEAN;
  v_BitB BOOLEAN;
BEGIN
  v_NumA := v_Mask;
  v_NumB := V_Value;
  IF v_NumA>=v_NumB THEN v_MaxParam:=v_NumA; ELSE v_MaxParam:=v_NumB; END IF;

  FOR i IN 0..31 LOOP
    v_CurrBit := POWER(2,i);
	IF v_CurrBit = v_MaxParam THEN
	  v_MaxBits := i;
	  EXIT;
	ELSIF v_CurrBit > v_MaxParam THEN
	  v_MaxBits := i-1;
	  EXIT;
    END IF;
  END LOOP;

  v_ResComp := 0;
  FOR i IN REVERSE 0..v_MaxBits LOOP
    v_CurrBit := POWER(2,i);
	IF v_CurrBit <= v_NumA THEN
      v_NumA := MOD(v_NumA,v_CurrBit);
	  v_BitA := TRUE;
    ELSE
	  v_BitA := FALSE;
	END IF;
	IF v_CurrBit <= v_NumB THEN
      v_NumB := MOD(v_NumB,v_CurrBit);
	  v_BitB := TRUE;
    ELSE
	  v_BitB := FALSE;
	END IF;
	IF v_BitA AND v_BitB THEN
      v_ResComp := v_ResComp + v_CurrBit;
    END IF;
  END LOOP;
  IF v_ResComp = v_Mask THEN
    RETURN (1);
  ELSE
    RETURN (0);
  END IF;
END;
/

